// -*- C++ -*-
/*!
 * @file SdoService.h
 * @brief SDO Service administration class
 * @date $Date: 2007-12-31 03:08:07 $
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2006-2008
 *     Noriaki Ando
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id: SdoService.h 706 2008-04-16 00:36:15Z n-ando $
 *
 */

/*!
 * @if jp
 * @namespace SDOPackage
 *
 * @brief SDO pbP[W
 *
 * @else
 *
 * @namespace SDOPackage
 *
 * @brief SDO package
 *
 * @endif
 */
namespace SDOPackage
{
  /*!
   * @if jp
   *
   * @class SDOServiceProfile
   * @brief SDO Service ProfileNX
   *
   * SDO Service Profile  SDO Service ̏ێ邽߂̃NXłB
   *
   * @since 0.4.0
   *
   * @else
   *
   * @class SDOServiceProfile
   * @brief SDO Service Profile class
   *
   * SDO Service Profile is a class to hold information of SDO Service.
   *
   * @since 0.4.0
   *
   * @endif
   */
  class SDOServiceProfile
    : public SDOpackage::ServiceProfile
  {
  public:
    /*!
     * @if jp
     *
     * @brief RXgN^
     * 
     * RXgN^
     *
     * @param id Service ID(ftHgl:"")
     * @param type Service ̌^(ftHgl:"")
     *
     * @else
     *
     * @brief Constructor
     * 
     * Constructor
     *
     * @param id ID of the Service(The default value:"")
     * @param type Type of the Service(The default value:"")
     *
     * @endif
     */
    SDOService(char* id = "", char type = "")
    {
    }
    
    /*!
     * @if jp
     *
     * @brief Service Profile擾
     * 
     * Service Profile擾
     * 
     * @return Service Profile
     * 
     * @else
     *
     * @brief Get Service Profile
     * 
     * Get Service Profile.
     * 
     * @return Service Profile
     * 
     * @endif
     */
    inline const SDOPackage::Service getProfile()
    {
      return *this;
    }
    
    /*!
     * @if jp
     * @brief ServiceProfile.id Zbg
     * 
     * SDO Service IDZbg
     * 
     * @param id Service ID
     * 
     * @else
     * @brief Set ServiceProfile.id
     * 
     * Set ID of SDO Service.
     * 
     * @param id ID of the Service
     * 
     * @endif
     */
    inline void setName(char* id)
    {
      // this->name is CORBA::string member of the struct
      this->id = id;
    }
    
    /*!
     * @if jp
     * @brief ServiceProfile.id 擾
     * 
     * SDO Service ID擾
     * 
     * @return Service ID
     * 
     * @else
     * @brief Get ServiceProfile.id
     * 
     * Get ID of SDO Service.
     * 
     * @return ID of the Service
     * 
     * @endif
     */
    inline const char* getName() const
    {
      return this->id;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.interfaceType Zbg
     * 
     * SDO Service interfaceTypeZbg
     * 
     * @param interfaceType Service interfaceType
     * 
     * @else
     * @brief Set SDOServiceProfile.interfaceType
     * 
     * Set interfaceType of SDO Service.
     * 
     * @param interfaceType interfaceType of the Service
     * 
     * @endif
     */
    inline void setInterfaceType(char* interfaceType)
    {
      this->interfaceType = interfaceType;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.interfaceType 擾
     * 
     * SDO Service interfaceType擾
     * 
     * @return Service interfaceType
     * 
     * @else
     * @brief Get SDOServiceProfile.interfaceType
     * 
     * Get interfaceType of SDO Service
     * 
     * @return interfaceType of the Service
     * 
     * @endif
     */
    inline const char* getInterfaceType() const
    {
      return this->interfaceType;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.idlDefinition Zbg
     * 
     * SDO Service idlDefinitionZbg
     * 
     * @param idlDefinition Service idlDefinition
     * 
     * @else
     * @brief Set SDOServiceProfile.idlDefnition
     * 
     * Set idlDefinition of SDO Service
     * 
     * @param idlDefinition idlDefinition of the Service
     * 
     * @endif
     */
    inline void setIdlDefinition(char* idlDefinition)
    {
      this->idlDefinition = idlDefinition;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.idlDefinition 擾
     * 
     * SDO Service idlDefinition擾
     * 
     * @return Service idlDefinition
     * 
     * @else
     * @brief Get SDO ServiceProfile.idlDefnition
     * 
     * Get idlDefinition of SDO Service
     * 
     * @return idlDefinition of the Service
     * 
     * @endif
     */
    inline const char* getIdlDefinition() const
    {
      return this->idlDefinition;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.properties Zbg
     * 
     * SDO Service propertiesZbg
     * 
     * @param properties Service properties
     * 
     * @else
     * @brief Set SDO ServiceProfile.properties
     * 
     * Set properties of SDO Service
     * 
     * @param properties Properties of the Service
     * 
     * @endif
     */
    inline void setProperties(NVList properties)
    {
      this->properties = properties;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.properties 擾
     * 
     * SDO Service properties擾
     * 
     * @return Service properties
     * 
     * @else
     * @brief Get SDO ServiceProfile.properties
     * 
     * Get properties of SDO Service
     * 
     * @return Properties of the Service
     * 
     * @endif
     */
    inline const NVList getProperties() const
    {
      return this->properties;
    }
    
    //	bool addProperty(char* name, CORBA::Any data);
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.serviceRef Zbg
     * 
     * SDO Service serviceRefZbg
     * 
     * @param serviceRef Serviceւ̎Q
     * 
     * @else
     * @brief Set SDO ServiceProfile.serviceRef
     * 
     * Set serviceRef of SDO Service.
     * 
     * @param serviceRef The reference to Service
     * 
     * @endif
     */
    inline void setServiceRef(RTCService_ptr serviceRef)
    {
      this->serviceRef = serviceRef;
    }
    
    /*!
     * @if jp
     * @brief SDO ServiceProfile.serviceRef 擾
     * 
     * SDO Service ւ̎QƂ擾
     * 
     * @return Serviceւ̎Q
     * 
     * @else
     * @brief Get SDO ServiceProfile.serviceRef
     * 
     * Get the reference to SDO Service
     * 
     * @return The reference to Service
     * 
     * @endif
     */
    RTCService_ptr getServiceRef() const
    {
      return this->serviceRef;
    }
  };
};
